<template>
  <div>
    <div class="statistics-title">
      {{ statisticsTitle }} <span title="Часовой пояс: Москва">UTC+3</span>
    </div>

    <div class="statistics-container">
      <router-link
        v-if="tenderData.leader"
        class="statistics-leader"
        target="_blank"
        :to="{ path: `/tenders-contractors/${tenderData.leader.uuid}` }"
      >
        {{ tenderData.leader.title }}
      </router-link>

      <div class="statistics-sum" v-if="tenderData.leader">{{ tenderData.leader.countPoints }} баллов</div>
      <div class="statistics-row">Приглашены <span>{{ tenderData.participants }}</span></div>
      <div class="statistics-row">Ознакомились <span>{{ tenderData.firstViewed }}</span></div>
      <div class="statistics-row">Заинтересовались <span>{{ tenderData.draftCreated }}</span></div>
      <div class="statistics-row">{{ isRFQ ? 'Отправили предложения' : 'Подали анкеты' }} <span>{{ tenderData.replySended }}</span></div>
      <div class="statistics-row" v-if="tenderData.winners">Победители <span>{{ tenderData.winners }}</span></div>
    </div>

    <div
      v-if="tender.status === 'HELD'"
      class="resend-invitation"
    >
      <ObButton
        label="Отправить приглашения повторно"
        type="outline"
        :mini="true"
        :disabled="isInvitationPending"
        @click="resendInvitation"
      />

      <div class="resend-invitation__description">
        Оправить повторно приглашения тем участникам,
        которые уже были приглашены в тендер, но ещё не ознакомились
      </div>
    </div>
  </div>
</template>

<script>
  import moment from 'moment'
  import { mapGetters } from 'vuex'
  import ObButton from 'common-components/src/obComponents/obButton'
  import api from '@/api'
  import { plural } from '@/helpers'

  export default {
    name: 'TenderStatistics',
    components: {
      ObButton
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    data () {
      return {
        isInvitationPending: false
      }
    },
    computed: {
      ...mapGetters({
        tenderData: 'tenders/tender'
      }),
      isRFQ: ({ tender }) => tender.type === 'RFQ',
      statisticsTitle: ({ tender }) => `${tender.leader ? 'Лидер' : 'Статистика'} на ${moment().locale('RU').format('LT')} ${moment().locale('RU').format('L')}`
    },
    methods: {
      async resendInvitation () {
        this.isInvitationPending = true

        const notificationId = new Date().getTime() + 'save'
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Отправка',
          id: notificationId
        })

        try {
          const { participantsCount, timeToResendLeft } = await api.tenders.resendInvitation(this.tender.uuid)

          const duration = moment.duration(timeToResendLeft, 'seconds')
          const formatDate = `${plural(Math.floor(duration.asHours()), ['час', 'часа', 'часов'])} ${plural(duration.minutes(), ['минуту', 'минуты', 'минут'])}`

          if (timeToResendLeft) {
            this.$notification({
              type: 'snackbars',
              timeout: 10000,
              message: `Повторная рассылка доступна раз в сутки. Вы сможете выполнить повторную рассылку ` +
                       `приглашений на участие в тендере через ${formatDate}`
            })
          } else {
            this.$notification({
              type: 'snackbars',
              timeout: 6000,
              message: `Приглашения повторно отправлены для участников: ${participantsCount}`
            })
          }
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка отправки приглашений'
          })
        }

        this.$notification({
          id: notificationId,
          event: 'close'
        })

        this.isInvitationPending = false
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .statistics-title {
    @include font-mixin(16px, 20px, 700, $color-text-base, 0.4px);

    text-align: center;
    margin-top: 38px;
    margin-bottom: 30px;

    span {
      color: #9da0ac;
    }
  }

  .statistics-container {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    max-width: 230px;
    margin: 0 auto 30px;
  }

  .statistics-row {
    display: flex;
    align-items: center;
    justify-content: space-between;
    margin-bottom: 12px;

    &:last-child {
      margin-bottom: 0;
    }
  }

  .statistics-leader {
    @include font-mixin(24px, 36px, 700, $blue-700);

    text-align: center;
    margin-bottom: 2px;
    display: block;
    text-decoration: none;
  }

  .statistics-sum {
    @include font-mixin(16px, 20px, 400, $blue-700);

    text-align: center;
    margin-bottom: 36px;
  }

  .resend-invitation {
    display: grid;
    justify-content: center;
    grid-auto-columns: min-content;
    grid-row-gap: 20px;

    &__description {
      @include font-mixin(12px, 12px, 400, $color-grey-label, 0.4px);

      text-align: center;
    }
  }
</style>